(** remove printing ~ *)

Set Implicit Arguments.

Require Import LibExtra DotTactics.
Require Import Coq.Program.Equality.
Require Import AbstractSyntax TypingMode GeneralTyping Indep Equivalence.
Require Import RecordTypes.

(** * A prefix of a record type *)
Inductive subrecord: typ->typ->Prop :=
| subrecord_refl T:
    subrecord T T
| subrecord_and T U D:
    subrecord T U ->
    subrecord T (typ_and U (typ_rcd D))
.

Lemma subrecord_has T U D:
  subrecord T U ->
  record_has T D ->
  record_has U D.
Proof.
  introv Hsu Hhas.
  induction Hsu.
  auto.
  eapply rh_andl; auto.
Qed.

Lemma subrecord_and_inv T U d:
  subrecord (typ_and T (typ_rcd d)) U ->
  subrecord T U.
Proof.
  introv Hsur.
  remember (typ_and T (typ_rcd d)).
  induction Hsur; subst.
  eapply subrecord_and. eapply subrecord_refl.
  eapply subrecord_and. eauto.
Qed.
  
(* A prefix of a record type is a record type *)
Lemma subrecord_record T U:
  subrecord T U ->
  record_type U ->
  record_type T.
Proof.
  introv Hsu Hhas.
  induction Hsu.
  auto.
  eapply IHHsu. clear Hsu IHHsu.
  hnf in *.
  destruct Hhas.
  inversions H.
  exists ls. auto.
Qed.
