Set Implicit Arguments.

Require Import Coq.Bool.Bool.
Require Import LibExtra DotTactics.

(** * Lemmas about booleans *)

Lemma leb_orb_inv hA hB hC:
  leb (hA || hB) hC ->
  exists hCA hCB,
  leb hA hCA /\
  leb hB hCB /\
  hC = (hCA || hCB).
Proof.
  introv Hleb.
  destr_bool.
  exists true true. simpls; eauto.
  exists true true. simpls; eauto.
  exists true true. simpls; eauto.
  exists true true. simpls; eauto.
  exists false false. simpls; eauto.
Qed.
Lemma leb_andb_inv hA hB hC:
  leb (hA && hB) hC ->
  exists hCA hCB,
  leb hA hCA /\
  leb hB hCB /\
  hC = (hCA && hCB).
Proof.
  introv Hleb.
  destr_bool.
  exists true true. simpls; eauto.
  exists true true. simpls; eauto.
  exists true true. simpls; eauto.
  exists true true. simpls; eauto.
  exists false true. simpls; eauto.
  exists true false. simpls; eauto.
  exists false false. simpls; eauto.
Qed.
Lemma leb_orb_1 hA hB:
  leb hA (hA || hB).
Proof.
  destr_bool.
Qed.
Lemma leb_orb_2 hA hB:
  leb hB (hA || hB).
Proof.
  destr_bool.
Qed.
Lemma leb_andb_1 hA hB:
  leb (hA && hB) hA.
Proof.
  destr_bool.
Qed.
Lemma leb_andb_2 hA hB:
  leb (hA && hB) hB.
Proof.
  destr_bool.
Qed.
Lemma leb_andb_orb1 hA hB hC:
  leb (hA && hC) ((hA || hB) && hC).
Proof.
  destr_bool.
Qed.
Lemma leb_andb_orb2 hA hB hC:
  leb (hB && hC) ((hA || hB) && hC).
Proof.
  destr_bool.
Qed.
Lemma leb_refl hA:
  leb hA hA.
Proof.
  destr_bool.
Qed.
Lemma leb_false hA:
  leb false hA.
Proof.
  destr_bool.
Qed.
Lemma leb_l hA hB hC:
  leb hA hB ->
  leb hA hC ->
  leb hA (andb hB hC).
Proof.
  destr_bool.
Qed.
Lemma leb_r hA hB hC:
  leb hA hB ->
  leb hC hB ->
  leb (orb hA hC) hB.
Proof.
  destr_bool.
Qed.
Lemma and_or_neg bA bB:
  ((bA && bB) || (negb bA)) = bB || (negb bA).
Proof.
  destr_bool.
Qed.
Lemma leb_trans hA hB hC:
  leb hA hB ->
  leb hB hC ->
  leb hA hC.
Proof.
  intros.
  destr_bool.
Qed.