Set Implicit Arguments.

Require Import Coq.Init.Datatypes.

Require Import LibExtra DotTactics.
Require Import Coq.Program.Equality.
Require Import
        AbstractSyntax GeneralTyping Generalization
        Similarity SyntaxSimilarity OperationalSemantics HeapUpdate
        Deref Defs ConfigValid.
Require Import HeapCorrespondence EnvCorrespondence HeapEvolution.
Require Import ConfigTyping ConfigVarkinds TFree.

(** * Additional lemams for similarity of heaps *)

Section WithTypingMode.
Context (typing_mode: Mode).

Lemma heap_sim_evo_strength_var_loc G v1 v2 xs1 xs2 w y:
  similar (w::xs1)%list (y::xs2)%list v1 v2 ->
  ctx_k G v1 v_loc ->
  ctx_k G v2 v_loc ->
  ctx_k G w v_ref ->
  similar xs1 xs2 v1 v2.
Proof.
  introv Hsi Hkv1 Hkv2 Hk.
  eapply similar_out_shorten_l.
  2: eauto.
  unfold fv, VarFreeVar.
  rewrite notin_singleton.
  intro; subst.
  forwards: ctx_k_eq Hk Hkv1.
  discriminate.
Qed.

End WithTypingMode.
  